//
//  PostureRecognizerController.h
//  PostureRecognizerTest
//
//  Created by Sebastian Hans on Fri Aug 27 2004.
//  Copyright (c) 2004 Sebastian Hans. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <centroidal_profile.h>
#import "WhiteOnGreenSegmentor.h"


@interface PostureRecognizerController : NSObjectController
{
	IBOutlet NSImageView *imageView;
	IBOutlet NSImageView *modelView;
	IBOutlet NSTextField *differenceField;
	IBOutlet NSComboBox *modelComboBox;
	IBOutlet NSStepper *differenceStepper;
	IBOutlet NSTextField *numPointsField;
	IBOutlet NSButton *segmentedModelCheckbox;
	IBOutlet NSButton *segmentedImageCheckbox;
	WhiteOnGreenSegmentor *segmentor;
	NSImage *current_image, *current_segmented_image;
	cp_model_t *current_model;
	cp_model_list_t *model_list;
	cp_match_list_t *match_list;
	long next_model_id;
	int current_difference_stepper_value;
}

- (IBAction) processImage: (id) sender;
- (IBAction) addModel: (id) sender;
- (IBAction) clearImage: (id) sender;
- (IBAction) rematch: (id) sender;
- (IBAction) enterModel: (id) sender;
- (IBAction) removeModel: (id) sender;
- (IBAction) useModelAsImage: (id) sender;
- (IBAction) useImageAsModel: (id) sender;
- (IBAction) stepDifference: (id) sender;
- (IBAction) setNumPoints: (id) sender;
- (IBAction) modelDisplayChange: (id) sender;
- (IBAction) imageDisplayChange: (id) sender;
- (IBAction) openModels: (id) sender;
- (void) displayImage;
- (void) displayModel;
- (void) setCurrentModel: (cp_model_t*) model;
- (NSString*) cString2NSString: (char*) s;
- (void) updateDifference;
- (void) addModel: (NSImage*) image as: (const char*) name;
- (BOOL) addModelFile: (NSString*) filename;
- (void) addModelFiles: (NSArray*) filenames;

@end
