//
//  Set.m
//  PostureRecognizer
//
//  Created by Sebastian Hans on Thu Sep 02 2004.
//  Copyright (c) 2004 Sebastian Hans. All rights reserved.
//

#import "Set.h"


@implementation Set

- (id) init
{
	size = 1;
	parent = nil;
	return self;
}

- (Set*) uniteWith: (Set*) otherSet
{
	Set *my_root, *other_root;

	my_root = [self find];
	if (!otherSet)
		return my_root;
	other_root = [otherSet find];
	if (other_root == my_root)
		return my_root;
	if (my_root->size >= other_root->size)
	{
		my_root->size += other_root->size;
		other_root->parent = my_root;
		return my_root;
	}
	else
	{
		other_root->size += my_root->size;
		my_root->parent = other_root;
		return other_root;
	}
}

- (Set*) find
{
	Set *root;
	
	root = self;
	while (root->parent)
		root = root->parent;
	if (root != self)
		parent = root;

	return root;
}

- (long) getSize
{
	return size;
}

@end
